#ifndef _TREE_H
#define _TREE_H

#include <stdbool.h>
#include <stdio.h>

typedef struct n {
  struct n *left, *right;
  int *ranks, n_ranks;
} node_t;

extern char *yytext;
extern FILE *yyin;
extern int yylineno;
extern int yylex(void);
int yyerror(const char *error);
int yyparse(void);

extern node_t *root;

void tree_parse(const char *filename);
int tree_n_leaves(node_t *root);
bool tree_rank_member(int test, node_t *node);
void tree_traverse(node_t *root, int level);
void tree_finalize(node_t *root);

#endif
